unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, StdCtrls, uInstanceManager;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FInstanceManager: TInstanceManager;
    procedure SecondInstanceStarted(const SentFromSecondInstance: TBytes);
  end;

var
  Form1: TForm1;

implementation

uses Windows;

{$R *.lfm}

procedure TForm1.FormCreate(Sender: TObject);
const
  CAppUnique = '{80E6829E-3859-4727-B9FD-14B792E58188}'; // By Ctrl+G in IDE
begin
  FInstanceManager := TInstanceManager.Create(CAppUnique);
  FInstanceManager.Check;
  case FInstanceManager.Status of
    isFirst:
      begin
        FInstanceManager.SetFormHandleForActivate(Handle);
        FInstanceManager.OnSecondInstanceStarted := @SecondInstanceStarted;
      end;
    isSecond:
      begin
        FInstanceManager.ActivateFirstInstance(BytesOf(GetCommandLineW));
        Application.Terminate;
      end;
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FInstanceManager.Free;
end;

procedure TForm1.SecondInstanceStarted(const SentFromSecondInstance: TBytes);
begin
  Label1.Caption := 'Second instance started with command line: ' +
    UTF8Encode(StringOf(SentFromSecondInstance));
end;

end.

